package com.sun.xml.internal.bind.v2.model.nav;

import com.sun.xml.internal.bind.v2.runtime.Location;
import java.util.Collection;

public interface Navigator<T, C, F, M>
{
    public abstract C getSuperClass(C p0);
    
    public abstract T getBaseClass(T p0, C p1);
    
    public abstract String getClassName(C p0);
    
    public abstract String getTypeName(T p0);
    
    public abstract String getClassShortName(C p0);
    
    public abstract Collection<? extends F> getDeclaredFields(C p0);
    
    public abstract F getDeclaredField(C p0, String p1);
    
    public abstract Collection<? extends M> getDeclaredMethods(C p0);
    
    public abstract C getDeclaringClassForField(F p0);
    
    public abstract C getDeclaringClassForMethod(M p0);
    
    public abstract T getFieldType(F p0);
    
    public abstract String getFieldName(F p0);
    
    public abstract String getMethodName(M p0);
    
    public abstract T getReturnType(M p0);
    
    public abstract T[] getMethodParameters(M p0);
    
    public abstract boolean isStaticMethod(M p0);
    
    public abstract boolean isSubClassOf(T p0, T p1);
    
    public abstract T ref(Class p0);
    
    public abstract T use(C p0);
    
    public abstract C asDecl(T p0);
    
    public abstract C asDecl(Class p0);
    
    public abstract boolean isArray(T p0);
    
    public abstract boolean isArrayButNotByteArray(T p0);
    
    public abstract T getComponentType(T p0);
    
    public abstract T getTypeArgument(T p0, int p1);
    
    public abstract boolean isParameterizedType(T p0);
    
    public abstract boolean isPrimitive(T p0);
    
    public abstract T getPrimitive(Class p0);
    
    public abstract Location getClassLocation(C p0);
    
    public abstract Location getFieldLocation(F p0);
    
    public abstract Location getMethodLocation(M p0);
    
    public abstract boolean hasDefaultConstructor(C p0);
    
    public abstract boolean isStaticField(F p0);
    
    public abstract boolean isPublicMethod(M p0);
    
    public abstract boolean isFinalMethod(M p0);
    
    public abstract boolean isPublicField(F p0);
    
    public abstract boolean isEnum(C p0);
    
    public abstract <P> T erasure(T p0);
    
    public abstract boolean isAbstract(C p0);
    
    public abstract boolean isFinal(C p0);
    
    public abstract F[] getEnumConstants(C p0);
    
    public abstract T getVoidType();
    
    public abstract String getPackageName(C p0);
    
    public abstract C loadObjectFactory(C p0, String p1);
    
    public abstract boolean isBridgeMethod(M p0);
    
    public abstract boolean isOverriding(M p0, C p1);
    
    public abstract boolean isInterface(C p0);
    
    public abstract boolean isTransient(F p0);
    
    public abstract boolean isInnerClass(C p0);
    
    public abstract boolean isSameType(T p0, T p1);
}
